<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Flex</title>

		<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>

	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 

		Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS. However, using bootsrap it is much easier and faster to imolement flex because all we have to do is add class="d-flex" to the parent of our flex items.

		Flex items, Flex children, when adding d-flex to their parent, the items are in a row. We can adjust their height and width  not like your inline elements.

		Flex Direction:

		You ca change the direction of your flex itemms by adding flex-direction, however, by default, flex-row is the arrangement of our flex item.

		Flex Row Reverse
			Starts our item from opposite side(right) and reverses the order of our flex items.
			
		flex-row starts from the left 	
		flex column starts from riight to left

		Flex column 
			flex column will arrange our 

	 -->
	 <!-- D-FLEX -->
	 <h3 class="text-center my-3">Flex Row</h3>
	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex mb-4">
		<span class="bg-primary p-2">Span Item 1</span>
		<span class="bg-danger p-2">Span Item 2</span>
		<span class="bg-success p-2">Span Item 3</span>
	</div>

	<!-- FLEX ROW REVERSE -->
	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- FLEX COLUMN -->
	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-column mb-4 p-4">
		<span class="bg-primary p-2">Span Item 1</span>
		<span class="bg-danger p-2">Span Item 2</span>
		<span class="bg-success p-2">Span Item 3</span>
	</div>

	<h3 class="text-center my-5">Flex Column Reverse</h3>
	<div class="d-flex flex-column-reverse bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<h2 class="text-center my-5">Justify Content</h2>
	<!-- justify-content allows us to manipulate annd change the alignment of our flex items along our main axis. The main axis for flex-row items is our x-axis. justify content allows us to horizontaly allign our flex-row item. -->
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- justify-content-start the default value of justify-content for flex items. it allows us to align our flex items to the start of their main axis. For flex-row it starts from the left, for flex-row-reverse it starts from the right. -->
	<div class="bg-dark d-flex flex-row justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- ALigns our flex items where our main axis end. For flex-row -->
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- 
		Align our flex-items at the center of the axis. The main axis for both flex-row and flex-row-reverse is the x-axis. Therefore, with jusstify-content-center we can center our items horizontally.
	 -->
	<h3 class="text-center my-5">Justify Content Center</h3>
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- 
		justify-content-between adds/distributes remaining spaces in between our items.
	
	 -->
	<h3 class="text-center my-5">Justify Content Between</h3>
	<div class="bg-dark d-flex flex-row justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- 
		Aligns our items by distributing space around your items. meaning it  will automatically calculate the space remaining and add that spaace around your item.
	 -->
	<h3 class="text-center my-5">Justify Content Around</h3>
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- ALIGN ITEM -->

	<!-- 
		align-items - aligns your items vertically for flex-row and flex-row-reverse

	 -->
	<h2 class="text-center">Align Items</h2>

	<!-- 
		align-items-start - aligns items at the start of the y- axis or cross-axis for flex-row and flex-row-reverse

			For flex-row and flex-row-reverse, the y axis is the cross axis and the x-axis is their main axis.

			for flex-column and flex-column-reverse, the y-axis is the main axis and x-axis is their cross axis.

		For flex-row and flex-row-reverse, the start of their y-axis is at the top.

	 -->
	<h3 class="text-center">Align Item Start</h3>

	<!--  -->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center">Align Item End</h3>
	<!-- align-items-end will align our flex-row and flex-row-reverse items at the end of their cross axis, which is tthe y-axis, meanning they will be at the bottom -->
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Item Center</h3>
	<!-- align-item-ceenter allows us to align our flex-row and flexx-roow-reverse item vertically. -->
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center">Align Items Horizonatally and Vertically</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- MINI ACTIVITY -->
	<h3 class="text-center my-5">Mini-Activity with flex Row</h3>
	<div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4 " style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4 " style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center my-5">Flex Column with Align Items annd Justify Content</h2>
	<!-- 
			For flex-row and flex-row-reverse, align-items aligns our flex-row annd flex-row-reverese vertically, justify-content aligns our flex-row annd flex-row-reverse horizontally.

			For flex-column and flex-column-reverse, align-items aligns our flex-column anf flex-column-reverese horizontally, justify-content aligns our flex-column and flex-column-reverse vertically.

	 -->
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>
	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>

	<!-- MINI ACTIVITY -->
	<!-- for column 
			align  -- x - horizintal
			justify -- y - vertical
	
		 -->
	<h3 class="text-center my-5">Mini-Activity</h3>
	<div class="d-flex flex-column justify-content-end bg-dark mb-4 flex-column"  style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>
	<div class="d-flex flex-column align-items-end bg-dark mb-4 flex-column " style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Column with Justify COntent Between and Around</h3>
	<div class="d-flex flex-column justify-content-between bg-dark mb-4 flex-column"  style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>
	<div class="d-flex flex-column jastify-content-around bg-dark mb-4 flex-column " style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2"style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Wrap</h3>
	<div class="d-flex flex-row flex-wrap justify-content-around bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>

	</div>

	<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>